<template>
  <PButton
    icon="mdi mdi-tune"
    class="p-button-text"
    :title="t('page.weekPlanning.filters.tune')"
    @click="isVisible = true"
  />

  <PDialog
    v-model:visible="isVisible"
    class="Config"
    modal
    :header="t('page.weekPlanning.filters.tune')"
    dismissable-mask
  >
    <label class="Config__Field">
      {{ t('page.weekPlanning.filters.days') }}
      <PInputNumber
        v-model="WeekPlanning.config.nbDays"
        mode="decimal"
        :min="1"
        show-buttons
        button-layout="horizontal"
        :allow-empty="false"
        increment-button-icon="pi pi-plus"
        decrement-button-icon="pi pi-minus"
      />
    </label>

    <label class="Config__Field Config__Field--inline">
      {{ t('page.weekPlanning.filters.granularity') }}
      <Dropdown
        v-model="WeekPlanning.config.hoursPerBlock"
        :options="WeekPlanning.getHoursPerBlockOptions(t)"
        option-label="label"
        option-value="value"
      />
    </label>

    <label class="Config__Field">
      {{ t('page.weekPlanning.filters.blockWidth') }}
      <PInputNumber
        v-model="WeekPlanning.config.blockWidth"
        mode="decimal"
        suffix=" px"
        :min="4"
        show-buttons
        button-layout="horizontal"
        :allow-empty="false"
        increment-button-icon="pi pi-plus"
        decrement-button-icon="pi pi-minus"
      />
    </label>

    <div class="Config__Field">
      <label>{{ t('page.weekPlanning.filters.workforces.label') }}</label>
      <span class="Config__FieldHelp">
        <i class="mdi mdi-information"></i>
        {{ t('page.weekPlanning.filters.workforces.help') }}
      </span>
      <PMultiSelect
        v-model="selectedWorkforces"
        :placeholder="t('page.weekPlanning.filters.workforces.placeholder')"
        :options="Resources.allWorkforces.value"
        option-label="name"
        option-value="id"
        :show-toggle-all="false"
        filter
      />
    </div>

    <div class="Config__Field">
      <Button :label="t('action.show')" @click="isVisible = false" />
    </div>

    <hr class="Config__Separator" />

    <div class="Config__Field Config__Settings">
      <span class="Config__SettingsSubtitle">{{
        t('page.weekPlanning.filters.manage')
      }}</span>
      <InputText
        v-model="settingsName"
        :label="t('resource.planningSettings.name')"
        edit
      />
      <Button
        icon="mdi mdi-plus"
        :label="t('action.save')"
        @click="addPlanningSettings"
      />
      <Button
        v-if="settings.planningSettings"
        class="p-button-danger p-button-outlined"
        icon="mdi mdi-delete-outline"
        :label="t('action.delete') + ` ${settings.planningSettings.name}`"
        @click="deletePlanningSettings"
      />
    </div>
  </PDialog>
</template>

<script lang="ts" setup>
import { useI18n } from 'vue-i18n'
import type { Workforce } from '@/api'
import { computed, onMounted, ref } from 'vue'
import type { ProvidedResources, ProvidedWeekPlanning } from '@/provided'
import { injectStrict } from '@/injectStrict'
import { ResourcesKey, SettingsKey, WeekPlanningKey } from '@/provided'
import Dropdown from 'primevue/dropdown/Dropdown.vue'
import InputText from '@/components/form/InputText.vue'
import Button from 'primevue/button/Button.vue'
import { planningSettingsClient } from '@/api'
import { useRouter } from 'vue-router'

const { t } = useI18n()
const isVisible = ref(false)
const workforces = ref<Array<Workforce>>([])

const Resources = injectStrict<ProvidedResources>(ResourcesKey)
const WeekPlanning = injectStrict<ProvidedWeekPlanning>(WeekPlanningKey)
const settings = injectStrict(SettingsKey)
const settingsName = ref('')

const selectedWorkforces = computed({
  get: () =>
    WeekPlanning.config.selectedWorkforces.filter((id) =>
      Resources.allId.value.includes(id)
    ),
  set: (value: Array<Workforce['id']>) =>
    (WeekPlanning.config.selectedWorkforces = value),
})

onMounted(async () => await Resources.loadWorkforces())

const router = useRouter()

async function addPlanningSettings() {
  const newPlanningSettings = await planningSettingsClient.create({
    blockWidth: WeekPlanning.config.blockWidth,
    selectedWorkforces: WeekPlanning.config.selectedWorkforces,
    granularity: WeekPlanning.config.hoursPerBlock,
    daysNumber: WeekPlanning.config.nbDays,
    mode: WeekPlanning.config.row,
    name: settingsName.value,
  })

  isVisible.value = false
  settings.planningSettings = newPlanningSettings
}

async function deletePlanningSettings() {
  if (settings.planningSettings) {
    isVisible.value = false

    await planningSettingsClient.delete(settings.planningSettings.id)
    settings.planningSettings = null
  }
}
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;

.Config {
  &__Field {
    display: flex;
    flex-direction: column;
    grid-gap: v.$spacing-2;
    margin-top: v.$spacing;

    :deep(.p-inputtext) {
      text-align: right;
    }

    &Help {
      border-radius: 5px;
      color: var(--cyan-600);
      font-size: small;
    }
  }

  &__Separator {
    margin-top: v.$spacing * 2;
    margin-bottom: v.$spacing;
  }

  &__Settings {
    &Subtitle {
      font-weight: bold;
    }
  }
}
</style>
